/*======================================商品自动裁图======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64Crop(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5Crop(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	DetectUrl := "https://ecimage.market.alicloudapi.com/commodity/crop"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64Crop("1.jpg")

	var output_size []int
	output_size = append(output_size, 640, 480)
	data["output_size"] = output_size
	data["object_ratio"] = 0.2 //商品占比，浮点，范围为(0, 1.0]
	data["padding_mode"] = 1   //补边模式，为0或者1，默认为0，当原图宽度或者高度不够时，回采取补边的方式，模式0为补充的颜色为背景色均值，模式1为拉伸补边方式，在背景比较纯色，没有杂物的情况下，建议采取模式1

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", DetectUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5Crop(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
